package model.obor;

import model.Energia;
import model.rytier.Rytier;

import java.io.Serializable;

public abstract class Obor implements Energia, Serializable {

	protected int energia;
	protected boolean hladny;

	public Obor(int energia) {
		this.energia = energia;
		// FIXME hladny nie je inicializovany
	}

	@Override
	public void nastavEnergiu(int energia) {
		this.energia = energia;
	}

	@Override
	public void znizEnergiu(int energia) {
		this.energia -= energia;
	}

	// Abstrakna trieda ma nenuti implementovat metody rozhrania
	@Override
	public int vratEnergiu() {
		return energia;
	}

	void nastav(boolean hladny) {
		this.hladny = hladny;
	}

	public void odveta(Rytier rytier) {
		if (energia > rytier.vratEnergiu()) {
			double novaEnergia = 0.9 * rytier.vratEnergiu();
			rytier.nastavEnergiu((int) novaEnergia);
		}
	}

}