package ui;

import stret.NerovnyPocetBojovnikovException;
import stret.Stret;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class StretOkno extends JFrame {

	// Buttons
	private JButton buttonStart;
	private JButton buttonFight;
	private JButton buttonCreateWarriors;
	private JButton buttonBack;

	private JButton[] buttons;

	// Text fields
	private JTextField rytieri = new JTextField(3);
	private JTextField statocniRytieri = new JTextField(3);
	private JTextField zliObri = new JTextField(3);

	// Labels
	private JLabel rytieriOzn = new JLabel("Rytieri");
	private JLabel statocniRytieriOzn = new JLabel("Statocni rytieri");
	private JLabel zliObriOzn = new JLabel("Zli obri");

	// Toto je pole, do ktoreho spravime vypis, zasadene do skrolovatelneho panelu
	private JTextArea vypis = new JTextArea(20, 30);
	private JScrollPane skrolVypis = new JScrollPane(vypis, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

	// Konstruktor okna
	public StretOkno(String nazov) {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE); // inak sa okno len skryje - plat aj WindowConstants.EXIT_ON_CLOSE
		setLayout(new FlowLayout());

		add(rytieriOzn);
		add(rytieri);
		add(statocniRytieriOzn);
		add(statocniRytieri);
		add(zliObriOzn);
		add(zliObri);

		buttonStart = new JButton("Start");
		buttonFight = new JButton("Fight");
		buttonCreateWarriors = new JButton("createWarriors");
		buttonBack = new JButton("Back");

		buttons = new JButton[] {
				buttonStart,
				buttonFight,
				buttonCreateWarriors,
				buttonBack
		};

		for (JButton bt : buttons) {
			add(bt);
		}

		add(skrolVypis);
		setTitle(nazov);

		pack(); // Zabezpeci optimalnu velkost okna vzhladom na obsah

		buttonBack.setVisible(false);
		setVisible(true);

		buttonStart.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {

				try {
					int pocetRytierov = Integer.parseInt(rytieri.getText());
					int pocetStatocnychRytierov = Integer.parseInt(statocniRytieri.getText());
					int pocetZlychObrov = Integer.parseInt(zliObri.getText());

					// Spustime boje zakazdym cez novy objekt stretu
					Stret stret = new Stret(
							pocetRytierov,
							pocetStatocnychRytierov,
							pocetZlychObrov
					);
					String vysledokStretu = stret.simulujStret();
					vypis.append(vysledokStretu);

					hideOtherButtons(buttonStart);

				} catch (NerovnyPocetBojovnikovException e) {
					//TODO je mozne posunut si spravu vnutri Vynimky, nemam ako vediet co je problem
					JOptionPane.showMessageDialog(StretOkno.this, "Nerovny pocet bojovnikov");
				} catch (Exception e) {
					JOptionPane.showMessageDialog(StretOkno.this, e.toString(), e.getMessage(), JOptionPane.ERROR_MESSAGE);
				}
			}
		});

		// Je moznost ist aj cez lambdy - ide o jednoduchy mechanizmus pre krajsi a uspornejsi zapis, v dnesnej dobe uz dost casto pouzivany//Je
		buttonBack.addActionListener(actionEvent -> {
			showAllOtherButtons();
			buttonBack.setVisible(false);
		});

	}

	protected void showAllOtherButtons() {
		for (JButton bt : buttons) {
			bt.setVisible(true);
		}

		buttonBack.setVisible(false);
	}

	protected void hideOtherButtons(JButton pressed) {
		for (JButton b : buttons) {
			if (b != pressed)
				b.setVisible(false);
		}

		buttonBack.setVisible(true);
	}

}
